<template>
  <div class="fr-container fr-p-5w">
    <TheHeader
      :title="title"
      :back-link="beneficiaryPath"
    />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main
          ref="formContainer"
          class="main-container fr-p-5w"
        >
          <AtomLoader
            v-if="pending"
            class="fr-mx-auto"
          />
          <AtomAlert
            v-else-if="error"
            :alert-type="AlertType.Error"
            :message="error"
          />
          <BeneficiaryForm
            v-else-if="beneficiary && agents.length"
            :beneficiary="beneficiary"
            :agents="agents"
            :is-submitting="isSubmitting"
            :household-relatives="householdRelatives"
            :relatives="relatives"
            @save-beneficiary="onUpdateBeneficiary"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { beneficiaryName } from '~/utils/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { getRandomId } from '~~/utils/random'
  import { Routes } from '~/utils/routing/routes'
  import { usePermissionsStore } from '~/store/permissions'

  definePageMeta({ middleware: 'is-beneficiary-referent' })

  const route = useRoute()
  const {
    $loadBeneficiary,
    $loadAgents,
    $updateItem,
    $snackbar,
    $loadBeneficiaryRelatives,
    $loadBeneficiaryHouseholdRelatives
  } = useNuxtApp()
  const permissionsStore = usePermissionsStore()

  const beneficiaryId = computed(() => route.params.id)

  const {
    data: beneficiary,
    pending: beneficiaryPending,
    error: beneficiaryError
  } = useLazyAsyncData(
    getRandomId(`beneficiary-${beneficiaryId.value}`),
    loadBeneficiary,
    { server: false }
  )

  const {
    data: agents,
    pending: agentsPending,
    error: agentsError
  } = useLazyAsyncData(getRandomId('agents'), $loadAgents, {
    server: false
  })

  const {
    data: householdRelatives,
    pending: householdRelativesPending,
    error: householdRelativesError
  } = useLazyAsyncData(
    getRandomId('householdRelatives'),
    loadBeneficiaryHouseholdRelatives,
    {
      server: false,
      default: () => []
    }
  )

  const {
    data: relatives,
    pending: relativesPending,
    error: relativesError
  } = useLazyAsyncData(getRandomId('relatives'), loadBeneficiaryRelatives, {
    server: false,
    default: () => []
  })

  const isSubmitting = ref(false)
  const formContainer = ref(null)

  const pending = computed(
    () =>
      beneficiaryPending.value ||
      agentsPending.value ||
      householdRelativesPending.value ||
      relativesPending.value
  )

  const error = computed(() => {
    if (beneficiaryError.value) {
      return "Les informations du bénéficiaire n'ont pas pu être chargées."
    }
    if (agentsError.value) return "La liste des agents n'a pas pu être chargée."
    if (householdRelativesError.value) {
      return "Les membres du foyer fiscal du bénéficiaire n'ont pas pu être chargés."
    }
    if (relativesError.value) {
      return "Les membres de l'entourage du bénéficiaire n'ont pas pu être chargés."
    }
    return ''
  })

  const title = computed(() =>
    beneficiary.value ? `Modifier ${beneficiaryName(beneficiary.value)}` : ''
  )

  const beneficiaryPath = computed(() =>
    Routes.Beneficiary(beneficiaryId.value)
  )

  const canAccessRelatives = computed(() => permissionsStore.canAccessRelatives)

  function loadBeneficiary() {
    return $loadBeneficiary(beneficiaryId.value)
  }

  function loadBeneficiaryHouseholdRelatives() {
    if (!canAccessRelatives.value) return
    return $loadBeneficiaryHouseholdRelatives(beneficiaryId.value)
  }

  function loadBeneficiaryRelatives() {
    if (!canAccessRelatives.value) return
    return $loadBeneficiaryRelatives(beneficiaryId.value)
  }

  async function onUpdateBeneficiary(_beneficiary) {
    isSubmitting.value = true

    try {
      const res = await $updateItem(
        `beneficiary`,
        beneficiary.value,
        _beneficiary
      )

      if (res.status === 200) return navigateTo(beneficiaryPath.value)
      throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error('La mise à jour du bénéficiaire a échoué.', () =>
        formContainer.value?.querySelector('input')?.focus()
      )
    }
    isSubmitting.value = false
  }
</script>
